/**************************************
 * DHT11温湿度声光报警实验
 * 室内温度不适宜时，闪烁LED提示
 * 室内湿度不适宜时，蜂鸣器工作
 * BY YFRobot
 **************************************/

//调用DHT11扩展库
#include <dht11.h>

dht11 DHT11;

#define DHT11PIN A0
int H_Buzzer = 2;     //定义数字口2为湿度指示
int T_Led = 3;       //定义数字口3为温度指示

void setup(){

  pinMode(H_Buzzer,OUTPUT); //定义数字口H_Buzzer为输出模式
  pinMode(T_Led,OUTPUT); //定义数字口T_Led为输出模式
  Serial.begin(9600);
  Serial.println("DHT11 Monitoring");
  Serial.print("\n");

}

void loop(){

  int val = DHT11.read(DHT11PIN);
  Serial.print("Read sensor: ");
  switch (val)
  {
  case DHTLIB_OK:
    Serial.println("OK");
    break;
  case DHTLIB_ERROR_CHECKSUM: 
    Serial.println("Checksum error"); 
    break;
  case DHTLIB_ERROR_TIMEOUT: 
    Serial.println("Time out error"); 
    break;
  default: 
    Serial.println("Unknown error"); 
    break;
  }

  //输出湿度值，并判断是否适合室内湿度，如不适则亮灯提醒
  Serial.print("Humidity (%): ");
  Serial.println((float)DHT11.humidity); 
  if((DHT11.humidity<=40) || (DHT11.humidity>=60))
   tone(2,2000);
  else 
    noTone(2);

  //输出温度值，并判断是否适合室内温度，如不适则亮灯提醒
  Serial.print("Temperature (oC): ");
  Serial.println((float)DHT11.temperature);
  if((DHT11.temperature<=18)||(DHT11.temperature>=25))
   Blink();
  else
    digitalWrite(T_Led,LOW);
  delay(2000);
}

void Blink(){
  for(int i=0;i<3;i++){
    digitalWrite(T_Led,HIGH);
    delay(500);
    digitalWrite(T_Led,LOW);
    delay(500);
  }
}


